#include <stdio.h>    /* for the printf function */
#include <stdlib.h>   /* for the atof function */
#include "functions.h"

int main(int argc, char **argv)
{
	int i;
	int n = 10;
	float xact, xn;
        
        /* Reading the initial guess from
           command line arguments */
	printf("argc=%d\n", argc);
	for (i = 0; i < argc; i++) {
		printf("argv[%d]=\"%s\"\n", i, argv[i]);
	}

        /* Were any arguments provided? 
           If yes, use the first argument as initial guess. */
	if (argc >= 2) {
		xn = atof(argv[1]);
	} else {
		xn = 0;
	}
	printf("start guess is %f\n", xn);

        /* Run newton */
	for (i = 0; i < n; i++) {
		xact = xn - f1x(xn) / df1dx(xn);

		xn = xact;
	}

        /* Print solution */
	printf("Solution is x=%f\n", xn);

	return 0;
}
