#include <math.h>
#include <stdio.h>
#include <stdlib.h>

void eval_fcn1(float x, float *pf, float *pdfdx)
{
	*pf = cos(x)-pow(x,3); 
	*pdfdx = -sin(x)-3*pow(x,2);
}

int main(int argc, char **argv)
{
	int i;
	int n = 10;
	float xact, xn, f, dfdx;

        /* Reading the initial guess from
           command line arguments */
	printf("argc=%d\n", argc);
	for (i = 0; i < argc; i++) {
		printf("argv[%d]=\"%s\"\n", i, argv[i]);
	}

        /* Were any arguments provided? 
           If yes, use the first argument as initial guess. */
	if (argc >= 2) {
		xn = atof(argv[1]);
	} else {
		xn = 0;
	}
	printf("start guess is %f\n", xn);

        /* Run newton */
	for (i = 0; i < n; i++) {
		eval_fcn1(xn, &f, &dfdx);
		xact = xn - f / dfdx;

		xn = xact;
	}

        /* Print solution */
	printf("Solution is x=%f\n", xn);

	return 0;
}
